"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AsyncTestLoadOnInit = exports.AsyncTest = void 0;
/* eslint-disable indent */
/* eslint-disable react/jsx-indent */
/* eslint-disable react/jsx-one-expression-per-line */
/* eslint-disable no-unused-vars */
/* eslint-disable react/prop-types */
const react_1 = __importDefault(require("react"));
const react_2 = require("@testing-library/react");
const demo_data_1 = require("./demo-data");
const use_async_object_manager_1 = require("./use-async-object-manager");
const cloneDeep_1 = __importDefault(require("lodash/cloneDeep"));
const sleep = (delay) => new Promise((res) => {
    setTimeout(function () {
        res();
    }, delay);
});
const Viz = ({ loadedData, saveData, updateData, updateFormData, resetData, reload, deleteObject, saveResponse, deleteResponse, loadingData, savingData, deletingData, data, uid, callCount, }) => (react_1.default.createElement("div", null,
    uid,
    react_1.default.createElement("button", { type: "button", className: "button-one", onClick: reload }, "Reload data"),
    react_1.default.createElement("div", null, loadingData ? 'loading data' : 'Loaded data'),
    react_1.default.createElement("div", null,
        "Loaded data:",
        react_1.default.createElement("span", null, JSON.stringify(loadedData))),
    react_1.default.createElement("div", null,
        "data:",
        react_1.default.createElement("span", null, JSON.stringify(data))),
    react_1.default.createElement("div", null,
        "Callcount: ",
        callCount),
    react_1.default.createElement("p", null,
        react_1.default.createElement("label", { htmlFor: "goodbyeInput" }, "Goodbye Input"),
        react_1.default.createElement("input", { id: "goodbyeInput", onChange: (e) => updateFormData('goodbye', e.target.value, false), value: (data === null || data === void 0 ? void 0 : data.goodbye) || '' })),
    react_1.default.createElement("p", null,
        react_1.default.createElement("button", { onClick: () => saveData() }, "Save"))));
const defaultArgs = {
    activeUid: demo_data_1.demoLoadedData.uid,
    collection: 'demoCollection',
    isNew: false,
    inputAdditionalData: {},
    schema: 'all',
    loadOnInit: false,
    asyncGetDocument: () => __awaiter(void 0, void 0, void 0, function* () { return ({}); }),
    asyncPutDocument: () => __awaiter(void 0, void 0, void 0, function* () { }),
    asyncPostDocument: () => __awaiter(void 0, void 0, void 0, function* () { }),
    asyncDeleteDocument: () => __awaiter(void 0, void 0, void 0, function* () { }),
};
const useDemoDatabase = () => {
    const [data, setData] = react_1.default.useState((0, cloneDeep_1.default)(demo_data_1.demoDbData));
    const asyncGetDocument = (collection, uid) => __awaiter(void 0, void 0, void 0, function* () {
        yield sleep(100);
        return data[collection][uid];
    });
    const asyncPutDocument = (collection, uid, objData) => __awaiter(void 0, void 0, void 0, function* () {
        yield sleep(100);
        setData((prev) => (Object.assign(Object.assign({}, prev), { [collection]: Object.assign(Object.assign({}, prev[collection]), { [uid]: Object.assign(Object.assign({}, prev[collection][uid]), objData) }) })));
    });
    const asyncPostDocument = (collection, uid, newData) => __awaiter(void 0, void 0, void 0, function* () {
        yield sleep(100);
        setData((prev) => (Object.assign(Object.assign({}, prev), { [collection]: Object.assign(Object.assign({}, prev[collection]), { [uid]: newData }) })));
    });
    const asyncDeleteDocument = (collection, uid) => __awaiter(void 0, void 0, void 0, function* () {
        yield sleep(100);
        setData((prev) => (Object.assign(Object.assign({}, prev), { [collection]: Object.assign(Object.assign({}, prev[collection]), { [uid]: undefined }) })));
    });
    // console.info(data);
    return {
        data,
        asyncGetDocument,
        asyncPutDocument,
        asyncPostDocument,
        asyncDeleteDocument,
    };
};
const AsyncTest = () => {
    const { data: dbData, asyncGetDocument, asyncPutDocument, asyncPostDocument, asyncDeleteDocument, } = useDemoDatabase();
    const { loadedData, saveData, updateData, updateFormData, resetData, reload, deleteObject, saveResponse, deleteResponse, loadingData, savingData, deletingData, data, uid, callCount, hasLoaded, initialData, unsavedChanges, isNew, } = (0, use_async_object_manager_1.useAsyncObjectManager)(Object.assign(Object.assign({}, defaultArgs), { asyncGetDocument,
        asyncPutDocument,
        asyncPostDocument,
        asyncDeleteDocument }));
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(Viz, { loadedData: loadedData, saveData: saveData, updateData: updateData, updateFormData: updateFormData, resetData: resetData, reload: reload, deleteObject: deleteObject, saveResponse: saveResponse, deleteResponse: deleteResponse, loadingData: loadingData, savingData: savingData, deletingData: deletingData, data: data, uid: uid, callCount: callCount, initialData: initialData, hasLoaded: hasLoaded, unsavedChanges: unsavedChanges, isNew: isNew }),
        react_1.default.createElement("div", null,
            react_1.default.createElement("h1", null, "Db data"),
            react_1.default.createElement("p", { "data-testid": "dbData" }, JSON.stringify(dbData)))));
};
exports.AsyncTest = AsyncTest;
exports.AsyncTest.waitForReady = () => __awaiter(void 0, void 0, void 0, function* () { });
const AsyncTestLoadOnInit = () => {
    const { data: dbData, asyncGetDocument, asyncPutDocument, asyncPostDocument, asyncDeleteDocument, } = useDemoDatabase();
    const { loadedData, saveData, updateData, updateFormData, resetData, reload, deleteObject, saveResponse, deleteResponse, loadingData, savingData, deletingData, data, uid, callCount, initialData, hasLoaded, unsavedChanges, isNew, } = (0, use_async_object_manager_1.useAsyncObjectManager)(Object.assign(Object.assign({}, defaultArgs), { loadOnInit: true, asyncGetDocument,
        asyncPutDocument,
        asyncPostDocument,
        asyncDeleteDocument }));
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(Viz, { loadedData: loadedData, saveData: saveData, updateData: updateData, updateFormData: updateFormData, resetData: resetData, reload: reload, deleteObject: deleteObject, saveResponse: saveResponse, deleteResponse: deleteResponse, loadingData: loadingData, savingData: savingData, deletingData: deletingData, data: data, uid: uid, callCount: callCount, initialData: initialData, hasLoaded: hasLoaded, unsavedChanges: unsavedChanges, isNew: isNew }),
        react_1.default.createElement("div", null,
            react_1.default.createElement("h1", null, "Db data"),
            react_1.default.createElement("p", { "data-testid": "dbData" }, JSON.stringify(dbData)))));
};
exports.AsyncTestLoadOnInit = AsyncTestLoadOnInit;
exports.AsyncTestLoadOnInit.waitForReady = () => __awaiter(void 0, void 0, void 0, function* () {
    yield react_2.screen.findByText('Loaded data');
});
//# sourceMappingURL=use-async-object-manager.composition.js.map