"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_2 = require("@testing-library/react");
const user_event_1 = __importDefault(require("@testing-library/user-event"));
const compositions = __importStar(require("./use-async-object-manager.composition"));
const demo_data_1 = require("./demo-data");
describe('Use async request hook', () => {
    describe('Compositions', () => {
        Object.entries(compositions).forEach(([name, Composition]) => {
            test(name, () => __awaiter(void 0, void 0, void 0, function* () {
                (0, react_2.render)(react_1.default.createElement(Composition, null));
                // @ts-ignore
                if (Composition.waitForReady)
                    yield Composition.waitForReady();
            }));
        });
    });
    describe('loading data', () => {
        test('should load data and show in composition', () => __awaiter(void 0, void 0, void 0, function* () {
            (0, react_2.render)(react_1.default.createElement(compositions.AsyncTestLoadOnInit, null));
            yield react_2.screen.getByText('loading data');
            yield react_2.screen.findByText('Loaded data');
            yield react_2.screen.findAllByText(JSON.stringify(demo_data_1.demoLoadedData));
        }));
        test('should load data when clicking reload button', () => __awaiter(void 0, void 0, void 0, function* () {
            (0, react_2.render)(react_1.default.createElement(compositions.AsyncTest, null));
            const loadBtn = react_2.screen.getByRole('button', { name: /Reload data/ });
            yield user_event_1.default.click(loadBtn);
            yield react_2.screen.getByText('loading data');
            yield react_2.screen.findByText('Loaded data');
            yield react_2.screen.findAllByText(JSON.stringify(demo_data_1.demoLoadedData));
        }));
        test.todo('should show loading message');
    });
    describe('Updating doc', () => {
        test('should change local data when editing input', () => __awaiter(void 0, void 0, void 0, function* () {
            (0, react_2.render)(react_1.default.createElement(compositions.AsyncTest, null));
            yield compositions.AsyncTest.waitForReady();
            const loadBtn = react_2.screen.getByRole('button', { name: /Reload data/ });
            yield user_event_1.default.click(loadBtn);
            yield react_2.screen.findByText('Loaded data');
            const formInputEl = react_2.screen.getByLabelText('Goodbye Input');
            yield user_event_1.default.clear(formInputEl);
            const newVal = 'New Value';
            yield user_event_1.default.type(formInputEl, newVal);
            const newData = Object.assign(Object.assign({}, demo_data_1.demoLoadedData), { goodbye: newVal });
            yield react_2.screen.findAllByText(JSON.stringify(newData));
            const dbData = react_2.screen.getByTestId('dbData').textContent;
            expect(dbData).toEqual(JSON.stringify(demo_data_1.demoDbData));
        }));
        test('should change database data when editing input and saving', () => __awaiter(void 0, void 0, void 0, function* () {
            (0, react_2.render)(react_1.default.createElement(compositions.AsyncTestLoadOnInit, null));
            yield compositions.AsyncTestLoadOnInit.waitForReady();
            const formInputEl = react_2.screen.getByLabelText('Goodbye Input');
            yield user_event_1.default.clear(formInputEl);
            const newVal = 'New Value';
            yield user_event_1.default.type(formInputEl, newVal);
            const newData = Object.assign(Object.assign({}, demo_data_1.demoLoadedData), { goodbye: newVal });
            yield react_2.screen.findAllByText(JSON.stringify(newData));
            const saveBtn = react_2.screen.getByRole('button', { name: /Save/ });
            yield user_event_1.default.click(saveBtn);
            const expectedDbData = Object.assign({}, demo_data_1.demoDbData);
            expectedDbData.demoCollection.abc.goodbye = newVal;
            yield (0, react_2.waitFor)(() => expect(react_2.screen.getByTestId('dbData').textContent).toEqual(JSON.stringify(expectedDbData)));
            const dbData = react_2.screen.getByTestId('dbData').textContent;
            expect(dbData).toEqual(JSON.stringify(expectedDbData));
        }));
        test.todo("should be able to update an array value");
        test.todo("should ");
    });
});
//# sourceMappingURL=use-async-object-manager.new.test.js.map